<?xml version="1.0" encoding="utf-8"?>
<s:TitleWindow xmlns:fx="http://ns.adobe.com/mxml/2009"
			   xmlns:s="library://ns.adobe.com/flex/spark"
			   xmlns:ui="library://ns.adobe.com/flex/ui"
			   xmlns:mx="library://ns.adobe.com/flex/mx"
			   xmlns:components="br.com.dclick.components.*"
			   close="titlewindowCloseHandler(event)" 
			   creationComplete="creationCompleteHandler(event)" 
			   title="Pesquisa de Usuario Liberacao Gerente" 
			   xmlns:visual="br.com.desenv.framework.component.visual.*"
			   maxWidth="1200" maxHeight="700" 
			    xmlns:autoComplete="br.com.desenv.framework.component.visual.autoComplete.*">
	
	<fx:Style source="../../../framework/util/estilo.css"/>
	
	
	<fx:Metadata>
		[Event(name="UsuarioLiberacaoGerenteSelecionadoEvent")]
	</fx:Metadata>
	
	<fx:Script>
		<![CDATA[
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;
			import br.com.desenv.framework.util.DsvObjectUtil;
			import mx.core.FlexGlobals;;
			import mx.collections.ArrayCollection;
			import mx.rpc.events.FaultEvent;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.controls.Alert;
			
			import mx.controls.DateField;
			import mx.events.CloseEvent;
			import mx.events.FlexEvent;
			import mx.managers.PopUpManager;
			
			
			import mx.validators.Validator;
			
			import spark.events.TitleWindowBoundsEvent;
			
			import br.com.desenv.nepalign.vo.Page;
			import br.com.desenv.nepalign.vo.Usuario;
			import br.com.desenv.nepalign.vo.UsuarioLiberacaoGerente;
			
			[Bindable]
			public var listaUsuarioLiberacaoGerente: ArrayCollection = new ArrayCollection();
			private var pageNumber: int = 1;
			private var totalRecords: int;
			private var pageSize: int = 15;
			private var lastPage: int = 1;
			
			[Bindable]
			private var listaUsuarioPesquisa: ArrayCollection = new ArrayCollection();
			
			private var usuario: Usuario;
			
			private var usuarioLiberacaoGerenteComponenteDetalhe: UsuarioLiberacaoGerenteComponenteDetalhe;
			[Bindable]
			public var pesquisaPelaTelaDeGerarDuplicata:Boolean = false;
			[Bindable]
			private var listaValidadorForm: Array = new Array();
			
			// ---------------------------------- FUNCOES DE INICIALIZACAO E FINALIZACAO --------------------------------			
			
			
			
			private function validar(event: MouseEvent):Boolean 
			{
				var listaErroValidador:Array = Validator.validateAll(this.listaValidadorForm);
				var validado:Boolean = listaErroValidador.length == 0;
				return validado;
			}
			
			// Indica todas as validacoes necessarias
			private function carregarListaValidacao(): void
			{
				//implemente aqui outros validadores se necessario
			}
			
			private function montarObjetoFiltro(): UsuarioLiberacaoGerente
			{
				var usuarioLiberacaoGerenteFiltro: UsuarioLiberacaoGerente = new UsuarioLiberacaoGerente();
				
				//usuarioLiberacaoGerenteFiltro.usuario = this.usuario;	
				usuarioLiberacaoGerenteFiltro.usuario = ignAutoCompleteUsuarioPesquisa.itemSelecionado as Usuario;			
				
				return usuarioLiberacaoGerenteFiltro;
			}
			
			private function creationCompleteHandler( event: FlexEvent ): void {
				carregarListaValidacao();
				
				var remoteObjectUsuarioLiberacaoGerente: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("usuarioLiberacaoGerenteService", listarResultHandler);	
				
				
				var usuarioLiberacaoGerenteFiltro: UsuarioLiberacaoGerente = new UsuarioLiberacaoGerente();
				remoteObjectUsuarioLiberacaoGerente.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1, usuarioLiberacaoGerenteFiltro); 
				if(pesquisaPelaTelaDeGerarDuplicata)
					datagridListaUsuarioLiberacaoGerente.setFocus();
			}
			
			protected function titlewindowCloseHandler(event:CloseEvent):void
			{
				if(!pesquisaPelaTelaDeGerarDuplicata)
					UPCPopUpManager.instance.removePopUp(this);
			}
			
			// ---------------------------------- RETORNO DA FUNCAO LISTAR  --------------------------------	
			
			private function listarResultHandler( event: ResultEvent ): void {
				var paginaUsuarioLiberacaoGerente: Page = event.result as Page;
				pageNumber = paginaUsuarioLiberacaoGerente.pageNumber;
				totalRecords = paginaUsuarioLiberacaoGerente.totalRecords;
				lastPage = paginaUsuarioLiberacaoGerente.lastPage();
				listaUsuarioLiberacaoGerente = paginaUsuarioLiberacaoGerente.recordList;
				labelPaginaAtual.text = "" + paginaUsuarioLiberacaoGerente.pageNumber;
				labelTotalRegistro.text = "Total de Registros " + paginaUsuarioLiberacaoGerente.totalRecords;
			}
			
			// CARREGANDO COMBOS			
			
			// ---------------------------------- ADICIONAR DINAMICAMENTE  --------------------------------				
			protected function buttonPesquisarUsuarioPesquisa_clickHandler(event:MouseEvent):void
			{
				var usuarioComponentePesquisa: UsuarioComponentePesquisa = new UsuarioComponentePesquisa();
				usuarioComponentePesquisa.addEventListener("UsuarioSelecionadoEvent", atualizarUsuarioPesquisaPorSelecaoResultHandler);
				UPCPopUpManager.instance.addPopUp(usuarioComponentePesquisa, this, true);
				UPCPopUpManager.instance.centerWindow(usuarioComponentePesquisa);
			}
			
			private function atualizarUsuarioPesquisaPorSelecaoResultHandler(e:ResultEvent):void
			{
				var novoUsuario: Usuario = e.result as Usuario;
				ignAutoCompleteUsuarioPesquisa.itemSelecionado = novoUsuario;
			}
			
			
			
			// -------------FUNCAO DE FILTRAR  -------------------------------------------------------			
			
			private function buttonFiltrarClickHandler( event: MouseEvent ): void {
				if (validar(event))
				{
					var remoteObjectUsuarioLiberacaoGerente: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("usuarioLiberacaoGerenteService", listarResultHandler);	
					remoteObjectUsuarioLiberacaoGerente.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1, montarObjetoFiltro());
				}	 
			}
			
			// -------------FUNCOES DE INSERIR E ATUALIZAR  -------------------------------------------------------			
			
			private function buttonInserir_clickHandler( event: MouseEvent): void 
			{
				var usuarioLiberacaoGerenteComponenteCadastro: UsuarioLiberacaoGerenteComponenteCadastro = new UsuarioLiberacaoGerenteComponenteCadastro();
				usuarioLiberacaoGerenteComponenteCadastro.usuarioLiberacaoGerente = new UsuarioLiberacaoGerente(); 
				usuarioLiberacaoGerenteComponenteCadastro.addEventListener("UsuarioLiberacaoGerenteIncluidoEvent", atualizarListaUsuarioLiberacaoGerentePorInclusaoResultHandler);
				UPCPopUpManager.instance.addPopUp(usuarioLiberacaoGerenteComponenteCadastro, this, true);
				UPCPopUpManager.instance.centerWindow(usuarioLiberacaoGerenteComponenteCadastro);
			}
			
			protected function buttonFechar_clickHandler(event:MouseEvent):void
			{
				var usuarioLiberacaoGerenteSelecionado: UsuarioLiberacaoGerente = datagridListaUsuarioLiberacaoGerente.selectedItem as UsuarioLiberacaoGerente;
				this.dispatchEvent(new ResultEvent("UsuarioLiberacaoGerenteSelecionadoEvent",false, true, usuarioLiberacaoGerenteSelecionado, null, null));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
			protected function datagridListaUsuarioLiberacaoGerente_doubleClickHandler(event:MouseEvent):void
			{
				if(pesquisaPelaTelaDeGerarDuplicata)
					buttonFechar_clickHandler(new MouseEvent(""));
				else{
					usuarioLiberacaoGerenteComponenteDetalhe = new UsuarioLiberacaoGerenteComponenteDetalhe();
					usuarioLiberacaoGerenteComponenteDetalhe.usuarioLiberacaoGerente = datagridListaUsuarioLiberacaoGerente.selectedItem as UsuarioLiberacaoGerente;
					usuarioLiberacaoGerenteComponenteDetalhe.addEventListener("UsuarioLiberacaoGerenteExcluidoEvent", atualizarListaUsuarioLiberacaoGerentePorExclusaoResultHandler);
					usuarioLiberacaoGerenteComponenteDetalhe.addEventListener("UsuarioLiberacaoGerenteAtualizadoEvent", atualizarListaUsuarioLiberacaoGerentePorAtualizacaoResultHandler);
					UPCPopUpManager.instance.addPopUp(usuarioLiberacaoGerenteComponenteDetalhe, this, true);
					UPCPopUpManager.instance.centerWindow(usuarioLiberacaoGerenteComponenteDetalhe);
				}
			}
			
			
			private function atualizarListaUsuarioLiberacaoGerentePorInclusaoResultHandler(e:Event):void
			{
				var remoteObjectUsuarioLiberacaoGerente: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("usuarioLiberacaoGerenteService", listarResultHandler);	
				remoteObjectUsuarioLiberacaoGerente.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage, montarObjetoFiltro()); 
			}
			
			private function atualizarListaUsuarioLiberacaoGerentePorAtualizacaoResultHandler(e:Event):void
			{
				var remoteObjectUsuarioLiberacaoGerente: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("usuarioLiberacaoGerenteService", listarResultHandler);	
				remoteObjectUsuarioLiberacaoGerente.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, pageNumber, montarObjetoFiltro()); 
				
			}
			
			
			private function atualizarListaUsuarioLiberacaoGerentePorExclusaoResultHandler(e:Event):void
			{
				var remoteObjectUsuarioLiberacaoGerente: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("usuarioLiberacaoGerenteService", listarResultHandler);	
				remoteObjectUsuarioLiberacaoGerente.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, pageNumber, montarObjetoFiltro()); 
			}
			
			
			
			
			
			// -------------FUNCOES DE NAVEGACAO -------------------------------------------------------			
			protected function linkButtonProximaPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectUsuarioLiberacaoGerente: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("usuarioLiberacaoGerenteService", listarResultHandler);	
				
				if (pageNumber < lastPage)
				{
					remoteObjectUsuarioLiberacaoGerente.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, (pageNumber + 1), montarObjetoFiltro());
				}
				else
				{
					remoteObjectUsuarioLiberacaoGerente.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage, montarObjetoFiltro());
				}				
			}
			
			protected function linkButtonAnteriorPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectUsuarioLiberacaoGerente: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("usuarioLiberacaoGerenteService", listarResultHandler);	
				
				if (pageNumber > 1)
				{
					remoteObjectUsuarioLiberacaoGerente.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, (pageNumber - 1) , montarObjetoFiltro());
				}
				else
				{
					remoteObjectUsuarioLiberacaoGerente.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1 , montarObjetoFiltro());
				}
			}
			
			protected function linkButtonPrimeiraPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectUsuarioLiberacaoGerente: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("usuarioLiberacaoGerenteService", listarResultHandler);	
				remoteObjectUsuarioLiberacaoGerente.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1 , montarObjetoFiltro()); 
			}
			
			protected function linkButtonUltimaPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectUsuarioLiberacaoGerente: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("usuarioLiberacaoGerenteService", listarResultHandler);	
				remoteObjectUsuarioLiberacaoGerente.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage , montarObjetoFiltro()); 
			}
			
			protected function datagridListaUsuarioLiberacaoGerente_keyDownHandler(event:KeyboardEvent):void
			{
				if(pesquisaPelaTelaDeGerarDuplicata)
					buttonFechar_clickHandler(new MouseEvent(""));
				
			}
			
		]]>
	</fx:Script>
	
	<fx:Declarations>
		<!-- Place non-visual elements (e.g., services, value objects) here -->
		<s:ArrayCollection id="listaOpcaoSimNao">
			<fx:Object codigo="" valor=""/>
			<fx:Object codigo="S" valor="Sim"/>
			<fx:Object codigo="N" valor="Nao"/>
		</s:ArrayCollection>
		
	</fx:Declarations>
	
	<mx:Grid styleName="grid" verticalScrollPolicy="auto" horizontalScrollPolicy="auto" maxHeight="600" maxWidth="1024">
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>
			
			
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Usuário:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoUsuarioPesquisa" styleName="labelValidacao" text="{ignAutoCompleteUsuarioPesquisa.errorString}"/>
					<s:HGroup>
						<autoComplete:IgnAutoComplete idKeyName="id" palavraChave="nome" id="ignAutoCompleteUsuarioPesquisa" enviarArgumentos="true" destino="usuarioService" funcaoChamada="listarPorObjetoFiltro" lenStartConsulta="3"  nomeClasseObjetoFiltro="br.com.desenv.nepalign.vo.Usuario" tabEnabled="true" />  
						<s:Button id="buttonPesquisarUsuarioPesquisa" width="30" label="..." click="buttonPesquisarUsuarioPesquisa_clickHandler(event)"/>
					</s:HGroup>
				</s:VGroup>
			</mx:GridItem>
			
			
			
			<mx:GridItem colSpan="2">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="right">
				<mx:Button id="buttonFiltrar" label="Filtrar" click="buttonFiltrarClickHandler(event)"/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4">
				<s:Spacer/>	
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				
				
				<mx:LinkButton id="linkButtonPrimeiraPagina" label="&lt;&lt;" click="linkButtonPrimeiraPagina_clickHandler(event)"/>
				<mx:LinkButton id="linkButtonAnteriorPagina" label="&lt;" click="linkButtonAnteriorPagina_clickHandler(event)"/>
				<mx:Label id="labelPaginaAtual" text=""/>
				<mx:LinkButton id="linkButtonProximaPagina" label="&gt;" click="linkButtonProximaPagina_clickHandler(event)"/>
				<mx:LinkButton id="linkButtonUltimaPagina" label="&gt;&gt;" click="linkButtonUltimaPagina_clickHandler(event)"/>				
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<mx:DataGrid id="datagridListaUsuarioLiberacaoGerente"  width="100%" verticalScrollPolicy="on" horizontalScrollPolicy="on" dataProvider="{listaUsuarioLiberacaoGerente}"
							 doubleClick="datagridListaUsuarioLiberacaoGerente_doubleClickHandler(event)" doubleClickEnabled="true"
							 keyDown="datagridListaUsuarioLiberacaoGerente_keyDownHandler(event)"
							 >
					<mx:columns>
						<mx:DataGridColumn visible="false" dataField="id"/>
						<mx:DataGridColumn dataField="usuario.nome" headerText="Usuário" resizable="true"/>
					</mx:columns>
				</mx:DataGrid>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>
			
			<mx:GridItem colSpan="2" horizontalAlign="left">
				<mx:Label id="labelTotalRegistro" text=""/>
			</mx:GridItem>
			<mx:GridItem colSpan="2" horizontalAlign="right">
				<mx:Button id="buttonInserir" visible="{!pesquisaPelaTelaDeGerarDuplicata}" label="Novo" click="buttonInserir_clickHandler(event)"/>
				<mx:Button id="buttonFechar" label="Fechar" click="buttonFechar_clickHandler(event)"/>
			</mx:GridItem>	
		</mx:GridRow>
		
	</mx:Grid>
</s:TitleWindow>
